/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package evaluacion1;

import arbol4D.Etiqueta;
import arbol4D.Funcion;
import arbol4D.Nodo4D;
import arbol4D.NodoAuxiliar;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Usuario
 */
public class Formulario extends javax.swing.JFrame {

    public static int P = 0;
    public static int H = 0;
    public static LinkedList<Double> Stack = new LinkedList<>();
    public static LinkedList<Double> Heap = new LinkedList<>();
    
    /**
     * Creates new form Formulario
     */
    public Formulario() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        Editor = new javax.swing.JTextPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        Consola = new javax.swing.JTextPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton1.setText("Evaluar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(Editor);

        jScrollPane2.setBackground(new java.awt.Color(0, 0, 0));
        jScrollPane2.setViewportView(Consola);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(169, 169, 169)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 188, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane2)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        try {
            InputStream stream = new ByteArrayInputStream(Editor.getText().getBytes(StandardCharsets.UTF_8));
            BufferedReader br = new BufferedReader(new InputStreamReader(stream));
            Analizador.A_Lexico p = new Analizador.A_Lexico(br);
            Analizador.A_Sintactico pars = new Analizador.A_Sintactico(p);
            pars.parse();
            Ejecucion(pars.Estructura);
        } catch (Exception ex) {
            Logger.getLogger(Formulario.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    public static int LineaActual = 0;
    
    public void Ejecucion(LinkedList<Nodo4D> EstructuraDS){
        int indice = 1;
        int ultimo = 1;
        if (EstructuraDS != null) {
            arbol4D.ContenedorEstatico.EstructuraDasm = new Hashtable<>();
            for (int i = 0; i < EstructuraDS.size(); i++) {
                if (!(EstructuraDS.get(i) instanceof Funcion)) {
                    arbol4D.ContenedorEstatico.EstructuraDasm.put(indice, EstructuraDS.get(i));
                    if (EstructuraDS.get(i) instanceof Etiqueta) {
                        Etiqueta etq = (Etiqueta) EstructuraDS.get(i);
                        arbol4D.ContenedorEstatico.Auxiliar.add(new NodoAuxiliar(indice, etq.valor));
                    }
                    indice++;
                }
            }
            ultimo = indice;
            for (int i = 0; i < EstructuraDS.size(); i++) {
                if (EstructuraDS.get(i) instanceof Funcion) {
                    Funcion actual = (Funcion) EstructuraDS.get(i);
                    arbol4D.ContenedorEstatico.Auxiliar.add(new NodoAuxiliar(indice, actual.Nombre));
                    for (int j = 0; j < actual.Contenido.size(); j++) {
                        arbol4D.ContenedorEstatico.EstructuraDasm.put(indice, actual.Contenido.get(j));
                        if (actual.Contenido.get(j) instanceof Etiqueta) {
                            Etiqueta etq = (Etiqueta) actual.Contenido.get(j);
                            arbol4D.ContenedorEstatico.Auxiliar.add(new NodoAuxiliar(indice, etq.valor));
                        }
                        indice++;
                    }
                }
            }
            arbol4D.ContenedorEstatico.LineaActual = ultimo;
            while (arbol4D.ContenedorEstatico.LineaActual != ultimo || !arbol4D.ContenedorEstatico.Incremento) {
                arbol4D.ContenedorEstatico.Incremento = true;
                Nodo4D actual = arbol4D.ContenedorEstatico.EstructuraDasm.get(arbol4D.ContenedorEstatico.LineaActual);
                LineaActual = LineaActual + 1;
                
                actual.Ejecutar();
                if (arbol4D.ContenedorEstatico.Incremento) {
                    arbol4D.ContenedorEstatico.LineaActual++;
                }
            }
        }
    }
    
    public static void ImprimirConsola(String texto){
        Consola.setText(Consola.getText() + texto);
    }   
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Formulario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Formulario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Formulario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Formulario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Formulario().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public static javax.swing.JTextPane Consola;
    private javax.swing.JTextPane Editor;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables
}
